import Combine

public extension Bus {
  final class Processor<Src, Dst> {
    var subscriptions = [AnyCancellable]()

    public init(
      _ keyIn: String,
      _ keyOut: String,
      _ handler: @escaping ((Src) -> Dst?),
      opt: [Option] = []
    ) {
      Bus.process([keyIn], keyOut, handler, opt: opt, sub: &subscriptions)
    }

    public init(
      _ keysIn: Set<String>,
      _ keyOut: String,
      _ handler: @escaping ((Src) -> Dst?),
      opt: [Option] = []
    ) {
      Bus.process(keysIn, keyOut, handler, opt: opt, sub: &subscriptions)
    }
  }
}
