import BusX
import Combine

extension Cord {
  final class Receive<T>: ObservableObject {
    @Published var value: T
    var subscriptions = [AnyCancellable]()
   
    init(
      _ key: String,
      _ defaultValue: T
    ) {
      value = defaultValue
      Bus.receive(
        [key],
        { [weak self] (_, v: T) in self?.value = v },
        sub: &subscriptions
      )
    }
  }
}
