import BusX
import SwiftUI

struct V: View {
  @StateObject var isJoinAvailable = Cord.Receive("joinAvailable", false)
  @StateObject var join = Cord.Button("join")
  @StateObject var textF = Cord.TextField("text.app", "text.ui")
  let test = Bus.Processor("text.ui", "joinAvailable", MeetupId.onlyAllowJoin)
  
  var body: some View {
    VStack {
      HStack {
        Text("Check text field:")
        Text("'\(textF.value)'")
          .fontWeight(.bold)
      }

      TextField("Binding-3", value: $textF.value, formatter: TextFieldValueOwner())
        .padding(8)
        .border(Color.blue, width: 2)

      Button(action: join.press.send) {
        Text("Join")
          .padding(8)
          .border(
            isJoinAvailable.value ? Color.green : Color.gray,
            width: isJoinAvailable.value ? 4 : 1
          )
      }
      .disabled(!isJoinAvailable.value)
    }
    .frame(width: 320)
    .padding()
  }
}
